/*
 * Simple calendar program.
 *
 * calendar <username> <password> {0|<uid>}
 *
 * ưȥ桼̾ȥѥɤʹƤ롥
 *
 * ư˻ꤵ줿桼̾(<username>)ȥѥ(<password>)
 *   Ϥ줿ˡư롥
 *
 * ưˤ<uid>ǻꤵ줿桼IDڤؤ롥
 *   (桼ȤΥϤˡ桼Υۡǥ쥯ȥ
 *    뤳Ȥ)
 *
 * 桼ڤؤԤᡤ̾ϥѡ桼ǵư롥
 *   桼ID˥ꤷˤϡ桼IDڤؤԤʤ
 *   (ƥѤ˰̥桼Ǽ¹Ԥ뤳Ȥ)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

void check_username(char *username, char *password, int uid);
void check_password(char *username, char *password, int uid);
int check_string(char *buffer, int len, char *string);
void puts_flush(char *message);
int input(char *message, char *buffer);
void command_exec(char *command);

/****************************************************************
 * ν桼̾ȥѥɤˤǧڸ塤
 * 桼IDڤؤƥư
 ****************************************************************/

void check_username(char *username, char *password, int uid)
{
  char buffer[16]; /* ϥХåե */
  int ok = 0;
  int len;

  /* 桼̾Υå */
  len = input("Username: ", buffer); /* 桼̾(ȼ) */
  if (check_string(buffer, len, username) != 0) { /* 桼̾ */
    fprintf(stderr, "Valid username: %.*s\n", len, buffer); /*  */
    ok = 1;
  } else {
    fprintf(stderr, "Invalid username: %.*s\n", len, buffer); /*  */
  }

  printf("Checked username: %.*s\n", len, buffer);
  puts_flush(NULL);

  if (ok == 0) { /* 桼̾԰ */
    puts_flush("Username is invalid");
    exit(0);
  }

  check_password(username, password, uid);
  exit(0);
}

void check_password(char *username, char *password, int uid)
{
  char buffer[16]; /* ϥХåե */
  int ok = 0;
  char *command = "cal";
  int len;

  /* ѥɤΥå */
  len = input("Password: ", buffer); /* ѥɤ(ȼ) */
  if (check_string(buffer, len, password) != 0) { /* ѥɤ */
    fprintf(stderr, "Login OK\n"); /*  */
    ok = 1;
  }

  puts_flush("Checked password");

  if (ok == 0) { /* ѥɤ԰ */
    puts_flush("Password is invalid");
    exit(0);
  }

  if (uid != 0) { /* 桼IDꤵƤ */
    if (setuid(uid) < 0) { /* 桼IDڤؤ */
      puts_flush("Cannot change user"); /* 顼ξ */
      puts_flush("Check whether this program runs as root");
      exit(0);
    }
  }

  /* 桼̾ */
  printf("%s calendar\n", username);
  puts_flush(NULL);

  /* ޥɼ¹ */
  command_exec(command);
}

/****************************************************************
 * ʹߤϥ饤֥ʤΤǡɬפ˱ƻȤ뤳
 ****************************************************************/

#define NO_TERMINATOR

/* ʸΰפΥå */
int check_string(char *buffer, int len, char *string)
{
#ifndef NO_TERMINATOR
  return strcmp(buffer, string) == 0;
#else
  if (len != strlen(string))
    return 0;
  if (strncmp(buffer, string, len) != 0)
    return 0;
  return 1;
#endif
}

/* å */
void puts_flush(char *message)
{
  if (message != NULL)
    printf("%s\n", message);
  fflush(stdout); /* ϥХåեեå */
}

/* åϸ塤ʸ(ԥɤޤǤϤ) */
int input(char *message, char *buffer)
{
  int i = 0;
  char c;

  printf("%s", message); /* å */
  puts_flush(NULL);

  /* Ԥ */
  while (read(0, &c, 1) == 1) { /* ʸ */
    if (c == '\r') continue; /* telnet³ιθ */
    if (c == '\n') break; /* ԥɤϤ줿齪λ */
    buffer[i++] = c;
  }
#ifndef NO_TERMINATOR
  buffer[i] = '\0'; /* ü\n(ԥ)\0֤ */
#endif

  return i;
}

/* ޥɼ¹ */
void call_exec(char *command)
{
  execlp(command, command, NULL);
}

/*
 * ޥɼ¹ԤϡŪ˥ʳΥӥˤб뤳Ȥ
 * ꤷơ¹Ԥ륳ޥɤȤƼꡤϿѤߤΥޥ
 * ɤåƼ¹Ԥ褦Ūʺˤ
 */
void command_exec(char *command)
{
  /*
   * ʲcalʳΥޥɤϿƤޤäƤ뤬ؿˡ
   * ƥѤʤɤϿƤcalʳ¾ޥɤ˺ǻĤä
   * ޤäƤȤ롥(㤨оŪˡưƤץ
   * ⡼ȤǼǤ褦ʥӥб뤳Ȥꤷơ
   * psޥɤϿϤƤΤޤ˺줿ʤ)
   */
  char *commands[] = { "ls", "ps", "cal", NULL }; /* ϿѤߥޥ */
  int i;

  for (i = 0; commands[i] != NULL; i++) { /* ϿѤߥޥɤ򸡺 */
    if (strcmp(command, commands[i]) == 0) { /* ҥåȤʤϿѤ */
      call_exec(command); /* ޥɼ¹ */
    }
  }
}

/* ƥѤ˺ؿ˺ǻĤäƤȤ */
void test_exec()
{
  call_exec("who");
}

/****************************************************************
 * ץμ¹ԤϤϤޤ
 ****************************************************************/

int main(int argc, char *argv[], char *envp[])
{
  char *username, *password;
  int uid;

  if (argc < 4) { /* ­ξϥإפϤλ */
    puts_flush("# calendar <username> <password> {0|<uid>}");
    exit(0);
  }

  username = argv[1];  /* 裱(桼̾) */
  password = argv[2];  /* 裲(ѥ) */
  uid = atoi(argv[3]); /* 裳(桼ID) */

  puts_flush("Input username and password, uid");
  puts_flush("is changed, the calendar of");
  puts_flush("the user is output, and flush");
  puts_flush("the buffer.\n");

  if ((uid != 0) && (getuid() != 0)) { /* root¤ǵưƤʤ */
    puts_flush("**************** ERROR ****************");
    puts_flush("* This program should be run as root! *");
    puts_flush("* Still when you want to run, specify *");
    puts_flush("* a zero as the user ID. When doing   *");
    puts_flush("* that, the user ID is not changed.   *");
    puts_flush("***************************************");
    exit(0);
  }

  /* 桼ǧڤ˿ʤ */
  check_username(username, password, uid);

  return 0;
}
